#include <gtk/gtk.h>
#include <gconf/gconf-client.h>

#define GCONF "/apps/tangogps"
#define TILESIZE 256


typedef struct {
	float lat;
	float lon;
//	int pixel_x;
//	int pixel_y;
} trackpoint_t;

typedef struct {
	char *name;
	char *uri;
	char *dir;
	int inverted_zoom;
} repo_t;

typedef struct {
	int type;
	char *nick;
	float lat;
	float lon;
	int head;
	int speed;
	char *lastseen;
	char *away_msg;
	int screen_x;
	int screen_y;
} friend_t;

typedef struct {
	char *filename;
	char *name;
	double lat;
	double lon;
	char *desc;
	int screen_x;
	int screen_y;
} photo_t;

typedef struct {
    double time;        /* Time of update, seconds since Unix epoch */
    int    mode;        /* Mode of fix */
    double latitude;    /* Latitude in degrees (valid if mode >= 2) */
    double longitude;   /* Longitude in degrees (valid if mode >= 2) */
    double altitude;    /* Altitude in meters (valid if mode == 3) */
    double track;       /* Course made good (relative to true north) */
    double speed;       /* Speed over ground, meters/sec */
} gps_fix_t;

typedef struct {
	gps_fix_t fix;
	int satellites_used;
	int satellites_inview;
	double hdop;
	gboolean valid;
} gps_data_t;

extern GdkPixmap 	*pixmap;
extern GtkWidget	*window1, *window2;
extern GtkWidget	*map_drawable;
extern GtkWidget	*dialog1;
extern GtkWidget	*window3;
extern char repo_dir[];
extern char *global_track_dir;

extern int global_x;
extern int global_y;
extern int global_zoom;

extern int mouse_dx; // for mouse move pixmap
extern int mouse_dy;

extern int global_units;

extern int global_drawingarea_width;
extern int global_drawingarea_height;


extern gps_data_t *gpsdata;

//extern trackpoint_t global_track_arr[10];

extern GSList		*trackpoint_list;
extern GSList		*friends_list;
extern GSList		*photo_list;
extern float		trip_distance;
extern double		trip_maxspeed;
extern double		trip_time;
extern double		trip_starttime;
extern gboolean		trip_counter_on;
extern trackpoint_t	global_myposition;
extern gboolean		trip_logger_on;

extern gchar		*global_curr_reponame;
extern int		global_repo_cnt;
extern GSList	 	*global_repo_list, *global_curr_repo;
extern GConfClient	*global_gconfclient;

extern gboolean		global_auto_download;
extern gboolean		global_mapmode;
extern gboolean		global_autocenter;
extern gboolean		global_reconnect_gpsd;

extern gchar		*global_server;
extern gchar		*global_port;

//overwrite tiles

//c.tile.openstreetmap.org/6/33/22.png
//mt0.g.com/mt?n=404&v=w2.63&x=3&y=5&zoom=13
// http://mt0.google.com/mt?n=404&v=w2.63&x=%d&y=%d&zoom=%d
// /home/m/Maps/google

// http://tile.openstreetmap.org/%d/%d/%d.png
// /home/m/Maps/OSM
